// Code generated by smithy-go-codegen DO NOT EDIT.

package bedrockagent

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/service/bedrockagent/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// List of Knowledge Bases associated to an existing Amazon Bedrock Agent Version
func (c *Client) ListAgentKnowledgeBases(ctx context.Context, params *ListAgentKnowledgeBasesInput, optFns ...func(*Options)) (*ListAgentKnowledgeBasesOutput, error) {
	if params == nil {
		params = &ListAgentKnowledgeBasesInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListAgentKnowledgeBases", params, optFns, c.addOperationListAgentKnowledgeBasesMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListAgentKnowledgeBasesOutput)
	out.ResultMetadata = metadata
	return out, nil
}

// List Agent Knowledge Bases Request
type ListAgentKnowledgeBasesInput struct {

	// Id generated at the server side when an Agent is created
	//
	// This member is required.
	AgentId *string

	// Version number generated when a version is created
	//
	// This member is required.
	AgentVersion *string

	// Max Results.
	MaxResults *int32

	// Opaque continuation token of previous paginated response.
	NextToken *string

	noSmithyDocumentSerde
}

// List Agent Knowledge Bases Response
type ListAgentKnowledgeBasesOutput struct {

	// List of Agent Knowledge Base Summaries
	//
	// This member is required.
	AgentKnowledgeBaseSummaries []types.AgentKnowledgeBaseSummary

	// Opaque continuation token of previous paginated response.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListAgentKnowledgeBasesMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListAgentKnowledgeBases{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListAgentKnowledgeBases{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListAgentKnowledgeBases"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddClientRequestIDMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddComputeContentLengthMiddleware(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = v4.AddComputePayloadSHA256Middleware(stack); err != nil {
		return err
	}
	if err = addRetryMiddlewares(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addOpListAgentKnowledgeBasesValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListAgentKnowledgeBases(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

// ListAgentKnowledgeBasesAPIClient is a client that implements the
// ListAgentKnowledgeBases operation.
type ListAgentKnowledgeBasesAPIClient interface {
	ListAgentKnowledgeBases(context.Context, *ListAgentKnowledgeBasesInput, ...func(*Options)) (*ListAgentKnowledgeBasesOutput, error)
}

var _ ListAgentKnowledgeBasesAPIClient = (*Client)(nil)

// ListAgentKnowledgeBasesPaginatorOptions is the paginator options for
// ListAgentKnowledgeBases
type ListAgentKnowledgeBasesPaginatorOptions struct {
	// Max Results.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListAgentKnowledgeBasesPaginator is a paginator for ListAgentKnowledgeBases
type ListAgentKnowledgeBasesPaginator struct {
	options   ListAgentKnowledgeBasesPaginatorOptions
	client    ListAgentKnowledgeBasesAPIClient
	params    *ListAgentKnowledgeBasesInput
	nextToken *string
	firstPage bool
}

// NewListAgentKnowledgeBasesPaginator returns a new
// ListAgentKnowledgeBasesPaginator
func NewListAgentKnowledgeBasesPaginator(client ListAgentKnowledgeBasesAPIClient, params *ListAgentKnowledgeBasesInput, optFns ...func(*ListAgentKnowledgeBasesPaginatorOptions)) *ListAgentKnowledgeBasesPaginator {
	if params == nil {
		params = &ListAgentKnowledgeBasesInput{}
	}

	options := ListAgentKnowledgeBasesPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListAgentKnowledgeBasesPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListAgentKnowledgeBasesPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListAgentKnowledgeBases page.
func (p *ListAgentKnowledgeBasesPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListAgentKnowledgeBasesOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	result, err := p.client.ListAgentKnowledgeBases(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

func newServiceMetadataMiddleware_opListAgentKnowledgeBases(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListAgentKnowledgeBases",
	}
}
