// Code generated by smithy-go-codegen DO NOT EDIT.

package lexmodelsv2

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/service/lexmodelsv2/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// The list of test set executions.
func (c *Client) ListTestExecutions(ctx context.Context, params *ListTestExecutionsInput, optFns ...func(*Options)) (*ListTestExecutionsOutput, error) {
	if params == nil {
		params = &ListTestExecutionsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListTestExecutions", params, optFns, c.addOperationListTestExecutionsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListTestExecutionsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListTestExecutionsInput struct {

	// The maximum number of test executions to return in each page. If there are
	// fewer results than the max page size, only the actual number of results are
	// returned.
	MaxResults *int32

	// If the response from the ListTestExecutions operation contains more results
	// than specified in the maxResults parameter, a token is returned in the response.
	// Use that token in the nextToken parameter to return the next page of results.
	NextToken *string

	// The sort order of the test set executions.
	SortBy *types.TestExecutionSortBy

	noSmithyDocumentSerde
}

type ListTestExecutionsOutput struct {

	// A token that indicates whether there are more results to return in a response
	// to the ListTestExecutions operation. If the nextToken field is present, you send
	// the contents as the nextToken parameter of a ListTestExecutions operation
	// request to get the next page of results.
	NextToken *string

	// The list of test executions.
	TestExecutions []types.TestExecutionSummary

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListTestExecutionsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListTestExecutions{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListTestExecutions{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListTestExecutions"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddClientRequestIDMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddComputeContentLengthMiddleware(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = v4.AddComputePayloadSHA256Middleware(stack); err != nil {
		return err
	}
	if err = addRetryMiddlewares(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addOpListTestExecutionsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListTestExecutions(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

// ListTestExecutionsAPIClient is a client that implements the ListTestExecutions
// operation.
type ListTestExecutionsAPIClient interface {
	ListTestExecutions(context.Context, *ListTestExecutionsInput, ...func(*Options)) (*ListTestExecutionsOutput, error)
}

var _ ListTestExecutionsAPIClient = (*Client)(nil)

// ListTestExecutionsPaginatorOptions is the paginator options for
// ListTestExecutions
type ListTestExecutionsPaginatorOptions struct {
	// The maximum number of test executions to return in each page. If there are
	// fewer results than the max page size, only the actual number of results are
	// returned.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListTestExecutionsPaginator is a paginator for ListTestExecutions
type ListTestExecutionsPaginator struct {
	options   ListTestExecutionsPaginatorOptions
	client    ListTestExecutionsAPIClient
	params    *ListTestExecutionsInput
	nextToken *string
	firstPage bool
}

// NewListTestExecutionsPaginator returns a new ListTestExecutionsPaginator
func NewListTestExecutionsPaginator(client ListTestExecutionsAPIClient, params *ListTestExecutionsInput, optFns ...func(*ListTestExecutionsPaginatorOptions)) *ListTestExecutionsPaginator {
	if params == nil {
		params = &ListTestExecutionsInput{}
	}

	options := ListTestExecutionsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListTestExecutionsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListTestExecutionsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListTestExecutions page.
func (p *ListTestExecutionsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListTestExecutionsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	result, err := p.client.ListTestExecutions(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

func newServiceMetadataMiddleware_opListTestExecutions(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListTestExecutions",
	}
}
