// Code generated by smithy-go-codegen DO NOT EDIT.

package migrationhubstrategy

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/service/migrationhubstrategy/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Retrieves a list of all the servers fetched from customer vCenter using
// Strategy Recommendation Collector.
func (c *Client) ListAnalyzableServers(ctx context.Context, params *ListAnalyzableServersInput, optFns ...func(*Options)) (*ListAnalyzableServersOutput, error) {
	if params == nil {
		params = &ListAnalyzableServersInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListAnalyzableServers", params, optFns, c.addOperationListAnalyzableServersMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListAnalyzableServersOutput)
	out.ResultMetadata = metadata
	return out, nil
}

// Represents input for ListAnalyzableServers operation.
type ListAnalyzableServersInput struct {

	// The maximum number of items to include in the response. The maximum value is
	// 100.
	MaxResults *int32

	// The token from a previous call that you use to retrieve the next set of
	// results. For example, if a previous call to this action returned 100 items, but
	// you set maxResults to 10. You'll receive a set of 10 results along with a token.
	// You then use the returned token to retrieve the next set of 10.
	NextToken *string

	// Specifies whether to sort by ascending (ASC) or descending (DESC) order.
	Sort types.SortOrder

	noSmithyDocumentSerde
}

// Represents output for ListAnalyzableServers operation.
type ListAnalyzableServersOutput struct {

	// The list of analyzable servers with summary information about each server.
	AnalyzableServers []types.AnalyzableServerSummary

	// The token you use to retrieve the next set of results, or null if there are no
	// more results.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListAnalyzableServersMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListAnalyzableServers{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListAnalyzableServers{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListAnalyzableServers"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddClientRequestIDMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddComputeContentLengthMiddleware(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = v4.AddComputePayloadSHA256Middleware(stack); err != nil {
		return err
	}
	if err = addRetryMiddlewares(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListAnalyzableServers(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

// ListAnalyzableServersAPIClient is a client that implements the
// ListAnalyzableServers operation.
type ListAnalyzableServersAPIClient interface {
	ListAnalyzableServers(context.Context, *ListAnalyzableServersInput, ...func(*Options)) (*ListAnalyzableServersOutput, error)
}

var _ ListAnalyzableServersAPIClient = (*Client)(nil)

// ListAnalyzableServersPaginatorOptions is the paginator options for
// ListAnalyzableServers
type ListAnalyzableServersPaginatorOptions struct {
	// The maximum number of items to include in the response. The maximum value is
	// 100.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListAnalyzableServersPaginator is a paginator for ListAnalyzableServers
type ListAnalyzableServersPaginator struct {
	options   ListAnalyzableServersPaginatorOptions
	client    ListAnalyzableServersAPIClient
	params    *ListAnalyzableServersInput
	nextToken *string
	firstPage bool
}

// NewListAnalyzableServersPaginator returns a new ListAnalyzableServersPaginator
func NewListAnalyzableServersPaginator(client ListAnalyzableServersAPIClient, params *ListAnalyzableServersInput, optFns ...func(*ListAnalyzableServersPaginatorOptions)) *ListAnalyzableServersPaginator {
	if params == nil {
		params = &ListAnalyzableServersInput{}
	}

	options := ListAnalyzableServersPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListAnalyzableServersPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListAnalyzableServersPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListAnalyzableServers page.
func (p *ListAnalyzableServersPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListAnalyzableServersOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	result, err := p.client.ListAnalyzableServers(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

func newServiceMetadataMiddleware_opListAnalyzableServers(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListAnalyzableServers",
	}
}
